import java.io.*;
import java.util.*;


public class polynomial {
double coefficient[];
int    degree;
static int maxdeg=5;
static Hashtable curPols;

  //get cofficients of polinomial and initialize them. Assign degree to the
  // most highest cofficient which is not zero
public polynomial(double incof[])
  {
    int d=0;
    coefficient = new double[maxdeg];
    for(int k=0;k<incof.length;k++){
      coefficient[k] = incof[k];
      if (incof[k] != 0)
	d = getMax(k,d);
    }
    degree = d;
  }

  //initializa polinomial to zeros
public polynomial()
 {
   coefficient = new double[maxdeg];
   for(int k=0;k<maxdeg;k++)
      coefficient[k] = 0.0;
   degree = 0;

 }

public int getDegree()
  {
    return degree;
  }

public  double[] getCoefficient()
  {
    return coefficient;
  }


public  String ToString()
  {
    String pols="";
    for(int k=degree;k>0;k--)
      pols += coefficient[k]+"x**"+k+ " + ";

    pols += coefficient[0];
    return pols;
  }

  //read polinomial degree and cofficients put them into its class fields
public   static polynomial readPolCof()
  {
    
    double []incof = new double[maxdeg];
    //DataInputStream dis = new DataInputStream(System.in);
    BufferedReader dis = new BufferedReader(new InputStreamReader(System.in));

    System.out.print("Enter polynomial degree:");
    try{
      //int indeg = dis.readInt();
      
      String sdeg = dis.readLine();
      int indeg = Integer.parseInt(sdeg);
      System.out.println("");
      for(int k=indeg;k>=0;k--){
	System.out.print("Enter coefficient["+k+"]:");

	String scof = dis.readLine();
	incof[k] = Double.parseDouble(scof);
	//incof[k] = dis.readDouble();
      }
    }catch(Exception ioexc){
      System.out.println("Exception Occured..:"+ioexc);
    }
    polynomial pol = new polynomial(incof);
    return pol;
  }

public  polynomial addPol(polynomial A)
  {
    double []Acof = A.getCoefficient();
    double []Bcof = getCoefficient(); 
    
    int inMinDeg = getMin(A.getDegree(), getDegree());

    double []Ccof = new double[maxdeg];
    for(int k=0;k<=inMinDeg;k++)
      Ccof[k] = Acof[k]+Bcof[k];

    //copy the rest
    int rest = getMax(A.getDegree(), getDegree());
    for(int k=inMinDeg+1;k<=rest;k++)
      Ccof[k] = Acof[k]+Bcof[k];

    polynomial pol = new polynomial(Ccof);
    return pol;
  }

public  int getMin(int a, int b)
  {
    int m = 0;
    if (a < b)
      m = a;
    else
      m = b;
    return m;
  }

public  int getMax(int a, int b)
  {
    int m = 0;
    if (a > b)
      m = a;
    else
      m = b;
    return m;
  }


public  polynomial subPol(polynomial A)
  {
    double []Acof = A.getCoefficient();
    double []Bcof = getCoefficient(); 
    int inMinDeg = getMin(A.getDegree(), getDegree());

    double []Ccof = new double[maxdeg];
    for(int k=0;k<=inMinDeg;k++)
      Ccof[k] = Acof[k]-Bcof[k];

    //copy the rest
    int rest = getMax(A.getDegree(), getDegree());
    for(int k=inMinDeg+1;k<=rest;k++)
      Ccof[k] = Acof[k]-Bcof[k];

    polynomial pol = new polynomial(Ccof);
    return pol;
  }

public  polynomial multPol(double constant)
  {
    double []Acof = getCoefficient();
    double []Ccof = new double[maxdeg];
    for(int k=0;k<maxdeg;k++)
      Ccof[k] = Acof[k]*constant;
    polynomial pol = new polynomial(Ccof);
    return pol;
  }

public static void parseInput(String input)
  {
    Vector tlist = new Vector();
    StringTokenizer st = new StringTokenizer(input, "+-()*=", true);
    while(st.hasMoreTokens()){
      String ns = st.nextToken();
      tlist.add(ns);
    }
    String first  = (String)tlist.get(0);
    String second = (String)tlist.get(1);

    //Read a polinomial X with X=
    if (tlist.contains("=")){
      String polName = (String)tlist.get(0);
      polynomial polVal = polynomial.readPolCof();
      curPols.put(polName, polVal);
      System.out.println("Result :"+polVal.ToString());
      System.out.println("TABLE :"+curPols);
    }
    //X+Y
    else if (tlist.contains("+")){
      String firstPolName = (String)tlist.get(0);
      String secondPolName = (String)tlist.get(2);
      polynomial A = (polynomial)curPols.get(firstPolName);
      polynomial B = (polynomial)curPols.get(secondPolName);
      polynomial resPol = A.addPol(B);
      System.out.println("Result :"+resPol.ToString());
    }
    //X-Y
    else if (tlist.contains("-")){
      String firstPolName = (String)tlist.get(0);
      String secondPolName = (String)tlist.get(2);
      polynomial A = (polynomial)curPols.get(firstPolName);
      polynomial B = (polynomial)curPols.get(secondPolName);
      polynomial resPol = A.subPol(B);
      System.out.println("Result :"+resPol.ToString());
    }
    //c*X
    else if (tlist.contains("*")){
      double constant = Double.parseDouble((String)tlist.get(0));
      polynomial A = (polynomial)curPols.get((String)tlist.get(2));
      polynomial resPol = A.multPol(constant);
      System.out.println("Result :"+resPol.ToString());
    }
    //val(X)
    else if (tlist.contains("val")){
      String polName = (String)tlist.get(2);
      polynomial resPol = (polynomial)curPols.get(polName);
      System.out.println("Result :"+resPol.ToString());
    }

  }


public static void main(String []args)
  {

    for(int k=0;k<args.length;k++)
      System.out.println("arg["+k+"]"+args[k]);

    boolean flag=false;
    curPols = new Hashtable();

    System.out.println("Type X= to read, X+Y and X-Y to add and substract");
    System.out.println("Type c*X to multiply X with c and val(X) to print X");
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    try{
      while(!flag){
	String input = br.readLine();
	parseInput(input);
      }
    }catch(IOException ioexc){System.out.println("Excp:"+ioexc);}
        
  }





}///END






